<?php
/*--------------------------------------------+
| GameStatusViewer     V 1.0     2005-07-26   |
| Game Americas Army                          |
|---------------------------------------------|
| Copyright Makro (Markus Kronier)  2005     |
| web: http://www.makromobil.de               |
| email: makro@makromobil.de                  |
|---------------------------------------------|
| Released under the terms and conditions of  |
| the GNU General Public License (Version 2)  |
+--------------------------------------------*/

require_once "CProt_GameSpy2.php";

class CGame_AAO {
  var $m_Prot;
  var $gameName      = "Americas Army";
  var $gameImagePath = "images/aao/";
  var $gameImage     = 'default';
  var $gameData      = array();
  var $playerData    = array();

  function CGame_AAO($serverIp, $queryPort) {
    $this->m_Prot = new CProt_GameSpy2($serverIp, $queryPort);
  }

  function PrepareGameData($gameData) {
    $this->gameData = array();

    $gameHeader = array("Host"=>"hostname","IP"=>"hostip","Map"=>"mapname","Gametype"=>"gametype","Round"=>"current_round");

    foreach ($gameHeader as $Key => $attr) {
      if ($gameData[$attr]) {
        $this->gameData[$Key]= $gameData[$attr];
        $this->gameData[$Key]= htmlspecialchars($this->gameData[$Key]);
        $this->gameData[$Key]= preg_replace("/\^[0-9]/","",$this->gameData[$Key]);
      }
    }
    //--- Map
    $this->gameImage      = strtolower(str_replace(' ','_', $this->gameData['Map']));

    //--- Players (current/max)
    if (($gameData['numplayers'] != "") && ($gameData['maxplayers'] != "")) {
      $this->gameData['Players'] = "(".$gameData['numplayers']."/".$gameData['maxplayers'].")";
    }
    //--- Teams
    if ($gameData['numteams'] != "") {
      $this->gameData['Teams'] = $gameData['numteams'];
    }

    //--- Honor (min/max)
    if (($gameData['minhonor'] !="0") && ($gameData['maxhonor'] != "")) {
      $this->gameData['Honor (min/max)'] = "(".$gameData['minhonor']."/".$gameData['maxhonor'].")";
    }
    //--- Official/leased
    if (($gameData['official'] != "") &&  ($gameData['leased']!="")) {
      $this->gameData['Official-Leased'] = "(".$gameData['official']."/".$gameData['leased'].")";
    }
    if ($gameData['queryport']) $this->gameData['QueryPort'] = $gameData['queryport'];
  }

  function PreparePlayerData($playerData) {
    $this->playerData = array();

    $playerHeader = array("Player"=>"player_","Honor"=>"honor_","Kills"=>"enemy_","KIA"=>"kia_", "Leader"=>"leader_", "Goals"=>"goal_","ROE"=>"roe_","Ping"=>"ping_");

    $playerIdx = 0;
    while ($playerData['player_'.$playerIdx]) {
      $player = array();
      foreach ($playerHeader as $Key => $attr) {
        $player[$Key] = $playerData[$attr.$playerIdx];
      }
      $player["Player"] = htmlspecialchars($player["Player"]);
      $player["Player"] = preg_replace("/\^[0-9]/","",$player["Player"]);  
      $this->playerData[] = $player;
      $playerIdx++;
    }
  }

  function ReadServerData() {
    //--- Read Game and Playerdata
    $error = $this->m_Prot->ReadServerData();
    if (!$error) {
      $gameData   = $this->m_Prot->GetGameData();
      $playerData = $this->m_Prot->GetPlayerData();

      //--- Get Gameinformation from Severdata
      $this->PrepareGameData  ($gameData);

      //--- Get Playerinformation from Serverdata
      $this->PreparePlayerData($playerData);
      return "";
    } else {
      return $error;
    }
  }
}

?>