<?php
/*--------------------------------------------+
| GameStatusViewer     V 1.0     2005-07-26   |
| Game Day of Defeat                          |
|---------------------------------------------|
| Copyright Makro (Markus Kronier)  2005     |
| web: http://www.makromobil.de               |
| email: makro@makromobil.de                  |
|---------------------------------------------|
| Released under the terms and conditions of  |
| the GNU General Public License (Version 2)  |
+--------------------------------------------*/

require_once "CProt_HalfLife_b.php";

class CGame_DoD {
  var $m_Prot;
  var $gameName      = "Day of Defeat";
  var $gameImagePath = "images/dod/";
  var $gameImage     = 'default';
  var $gameData      = array();
  var $playerData    = array();

  function CGame_DoD($serverIp, $queryPort) {
    $this->m_Prot = new CProt_HalfLife_b($serverIp, $queryPort);
  }

  function PrepareGameData($gameData) {
    $this->gameData = array();

    $gameHeader = array("Host"=>"hostname", "IP"=>"serverip", "Game"=>"gamename", "Map"=>"mapname", "Dedicated"=>"dedicated","Server-OS"=>"serveros","Password"=>"password","Modded"=>"modded");
    foreach ($gameHeader as $Key => $attr) {
      if ($gameData[$attr]) {
        $this->gameData[$Key]= $gameData[$attr];
        $this->gameData[$Key]= htmlspecialchars($this->gameData[$Key]);
        $this->gameData[$Key]= preg_replace("/\^[0-9]/","",$this->gameData[$Key]);
      }
    }
    //--- Players (current/max)
    if (($gameData['numplayers']!="") && ($gameData['maxplayers']!="")) {
      $this->gameData['Players'] = "(".$gameData['numplayers']."/".$gameData['maxplayers'].")";
    }
    //--- Map
    $this->gameImage      = strtolower(str_replace(' ','_', $this->gameData['Map']));
  }

 function PreparePlayerData($playerData) {
    $this->playerData = array();

    $playerHeader = array("PlayerId"=>"id_","Player"=>"player_","Score"=>"score_","Time"=>"time_");
    $playerIdx = 0;

    while ($playerData['player_'.$playerIdx]) {
      $player = array();
      foreach ($playerHeader as $Key => $attr) {
        $player[$Key] = $playerData[$attr.$playerIdx];
      }
      $player["Player"] = htmlspecialchars($player["Player"]);
      $player["Player"] = preg_replace("/\^[0-9]/","",$player["Player"]);  
      $this->playerData[] = $player;
      $playerIdx++;
    }
  }

  function ReadServerData() {
    //--- Read Game and Playerdata
    $error = $this->m_Prot->ReadServerData();
    if (!$error) {
      $gameData   = $this->m_Prot->GetGameData();
      $playerData = $this->m_Prot->GetPlayerData();

      //--- Get Gameinformation from Severdata
      $this->PrepareGameData  ($gameData);

      //--- Get Playerinformation from Serverdata
      $this->PreparePlayerData($playerData);
      return "";
    } else {
      return $error;
    }
  }
}

?>