<?php
/*--------------------------------------------+
| GameStatusViewer     V 1.0     2005-07-26   |
| Quake3 Protocoll                            |
|---------------------------------------------|
| Copyright Makro (Markus Kronier)  2005     |
| web: http://www.makromobil.de               |
| email: makro@makromobil.de                  |
|---------------------------------------------|
| Released under the terms and conditions of  |
| the GNU General Public License (Version 2)  |
+--------------------------------------------*/

class CProt_Quake3 {

  var $m_serverIp;
  var $m_queryPort;

  //---------------
  var $m_requestCmd          = "";
  //---------------

  var $m_serverData;

  function CProt_Quake3($serverIp, $queryPort) {
    $this->m_serverIp    = $serverIp;
    $this->m_queryPort   = $queryPort;
    $this->m_requestCmd  = "\xFF\xFF\xFF\xFFgetstatus";
  }

  function ReadServerData() {
    $error = "";
    $this->m_serverData = '';

    $socket = @fsockopen('udp://'. $this->m_serverIp, $this->m_queryPort, $errno, $errstr, 10);
    if ($socket) {
      socket_set_timeout($socket, 2);
      //--- Send request to Server
      fwrite($socket, $this->m_requestCmd);

      //--- Read response
      $part = fread($socket,2048);
      if ($part) $this->m_serverData .= $part;
      fclose($socket);
    } else {
      $error = "not connected to the server!";
    }
    return $error;
  }

  function GetGameData() {
    $data     = explode("\x0A", $this->m_serverData);
    $data[1]  = explode("\\", $data[1]);
    $gameData = array();

    $gameData["hostip"] = $this->m_serverIp;
    $gameData["queryport"] = $this->m_queryPort;

    $i = 1;
    while ($i < count($data[1])-1) {
      $gameData[$data[1][$i]]= $data[1][$i+1];
      $i+=2;
    }
    return $gameData;
  }

  function GetPlayerData() {
    $data       = explode("\x0A", $this->m_serverData);
    $playerData = array();
    $i = 2;
    if (count($data) > 2) {
      while ($i < count($data)) {
        if (preg_match("/(\d+)[^0-9](\d+)[^0-9](\d+)[^0-9]\"(.*)\"/", $data[$i], $playerFields)) {
          $playerFields[4] = preg_replace("/(\^\d)?/","",$playerFields[4]);
          $playerFields[4] = htmlspecialchars($playerFields[4]);

          $playerData["score_" .($i-2)] = $playerFields[1];
          $playerData["team_"  .($i-2)] = $playerFields[2];
          $playerData["ping_"  .($i-2)] = $playerFields[3];
          $playerData["player_".($i-2)] = $playerFields[4];
        } else
        if (preg_match("/(\d+)[^0-9](\d+)[^0-9]\"(.*)\"/", $data[$i], $playerFields)) {
          $playerFields[3] = preg_replace("/(\^\d)?/","",$playerFields[3]);
          $playerFields[3] = htmlspecialchars($playerFields[3]);

          $playerData["score_" .($i-2)] = $playerFields[1];
          $playerData["ping_"  .($i-2)] = $playerFields[2];
          $playerData["player_".($i-2)] = $playerFields[3];
        }
        $i++;
      }
    }
    return $playerData;
  }
}

?>