<?php
/*--------------------------------------------+
| Gamestats Viewer Infusion for               |
| PHP-Fusion 6 Content Management System      |
| Copyright  2002 - 2005 Nick Jones          |
| http://www.php-fusion.co.uk/                |
+---------------------------------------------+
| Gamestats Viewer Infusion                   |
| author: Makro (Markus Kronier)
| Copyright  2005                            |
| web: http://www.makromobil.de              |
| email: makro@makromobil.de                  |
|---------------------------------------------|
| Released under the terms and conditions of  |
| the GNU General Public License (Version 2)  |
+--------------------------------------------*/

require_once "../../maincore.php";
require_once BASEDIR."subheader.php";
require_once BASEDIR."side_left.php";

if (!FUSION_QUERY || !gamestats_id) fallback("../../index.php");

// Check if locale file is available matching the current locale setting.
if (file_exists(INFUSIONS."gamestats_panel/locale/".$settings['locale'].".php")) {
  // Load the locale file matching the current site locale setting.
  include INFUSIONS."gamestats_panel/locale/".$settings['locale'].".php";
} else {
  // Load the infusion's default locale file.
  include INFUSIONS."gamestats_panel/locale/English.php";
}

//--- GameViewer
require_once "CGame_Viewer.php";

$data = dbarray(dbquery("SELECT * FROM ".$db_prefix."gamestats WHERE gamestats_id='$gamestats_id'"));
$server_ip  = $data['server_ip'];
$query_port = $data['query_port'];
$game_type  = $data['game_type'];

//--- Create Game
switch ($game_type) {
  case "AAO":   //--- Americas Army 2.4
    require_once "CGame_AAO.php";
    $game = new CGame_AAO($server_ip,$query_port);
    break;
  case "BFV":  //--- Battlefield Vietnam
    require_once "CGame_BFV.php";
    $game = new CGame_BFV($server_ip,$query_port);
    break;
  case "CoD":  //--- Call of Duty
    require_once "CGame_CoD.php";
    $game = new CGame_CoD($server_ip,$query_port);
    break;
  case "CSS":  //--- Counter-Strike Source
    require_once "CGame_CSS.php";
    $game = new CGame_CSS($server_ip,$query_port);
    break;
  case "DoD":  //--- Day of Defeat
    require_once "CGame_DoD.php";
    $game = new CGame_DoD($server_ip,$query_port);
    break;
  case "MoHAA":  //--- Medal of Honor
    //require_once "CGame_MoH.php";
    //$game = new CGame_MoH($server_ip,$query_port);
    break;
  case "UT2004":  //--- Unreal Tournament 2003
    //require_once "CGame_UT2004.php";
    //$game = new CGame_UT2004($server_ip,$query_port);
    break;
  case "HL2":    //--- Halflife2
    //require_once "CGame_HL2.php";
    //$game = new CGame_HL2($server_ip,$query_port);
    break; 
  case "BF2":    //--- Battlefield 2 
    //require_once "CGame_BF2.php";
    //$game = new CGame_BF2($server_ip,$query_port);
    break;    
}

opentable($locale['GSV100']);

//--- Create Viewer
if (isset($game)) {
  $Viewer = new CGame_Viewer($game);
  echo $Viewer->Get_GameServerInfo();
} else {
  echo $locale['GSV200'];
}

closetable();

require_once BASEDIR."side_right.php";
require_once BASEDIR."footer.php";
?>